//
//  HC-SR04 Demo program. Modified from howtomechatronics
// 3/10/25               -jkl
// 3/11/25 Modified for G431   -jkl
// !!!!!!!!!!!! HC-SR04 Echo pin must be hooked to a 5V tolerant input !!!!!!!!!!!
// HardWare Serial must be used.
//

// Order is Rx,Tx
HardwareSerial mySerial(23,24);   // Usart 1

// 18 is a good 5V tolerant input. Can use 17 for the output trigger.
const int trigPin = 17;
const int echoPin = 18;

void setup() 
{
	mySerial.begin(115200);
	pinMode(trigPin, OUTPUT);
	pinMode(echoPin, INPUT);
}

void loop() 
{
  long duration;
  int distance;
	// Write a pulse to the HC-SR04 Trigger Pin
	digitalWrite(trigPin, LOW);
	delayMicroseconds(2);
	digitalWrite(trigPin, HIGH);
	delayMicroseconds(10);
	digitalWrite(trigPin, LOW);
	
	// Measure the response from the HC-SR04 Echo Pin
	duration = pulseIn(echoPin, HIGH);
	
	// Determine distance from duration
	// Use 343 metres per second as speed of sound
	distance= duration*0.034/2;

	mySerial.print("Distance: "); 
	mySerial.print(distance);
	mySerial.println(" cm");

	delay(500);
}